# Supplementary Materials for (Improving DBSCAN for Indoor Positioning Using Wi-Fi Radio Maps in Wearable and IoT Devices)

### Overview 

This package contains all the functions used to run the experiments in the paper cited below. Please, if you want to use this software, don't forget to cite the source.

* Quezada-Gaibor, D., Klus, L., Torres-Sospedra, J., Lohan, E. S., Nurmi, J. and Huerta, J., 2020, October. Improving DBSCAN for Indoor Positioning Using Wi-Fi Radio Maps in Wearable and IoT Devices, In 2020 12th International Congress on Ultra Modern Telecommunications and Control Systems and Workshops (ICUMT) (pp. 208-213). IEEE. https://doi.org/10.1109/ICUMT51630.2020.9222411

Note: This package is based on the material provided by Torres-Sospedra et al. (https://zenodo.org/record/3751042)
* Torres-Sospedra, J.; Quezada-Gaibor, D.; Mendoza-Silva, G. M.; Nurmi, J.; Koucheryavy, Y. and Huerta, J. "New Cluster Selection and Fine-grained Search for k-Means Clustering and Wi-Fi Fingerprinting". In Proceedings of the Tenth International Conference on Localization and GNSS (ICL-GNSS), 2020.

If you would like to re-use the databases included in this paper, please cite the corresponding sources as indicated in the readme file in the folder 'databases'.

### Disclaimer

1. DBSCAN post-processing method implemented in this package is just another way of improving the accuracy of the position estimation. 
 
### Requirements for running it locally

* **Software required**

	The project has been developed by using the following software :

	- GNU Octave, version 5.2.0


### Content package

Please check the information provided by Torres-Sospedra et al. in their software (00_README.md)

* **New functions added**

    zenodo_3983634/dbscan_imp_mod.m -- Local implementation of DBSCAN based on S. Mostapha Kalami Heris' code. Here the centroid of each cluster is computed and it calls the post-processing method. 
    
    zenodo_3983634/dbscan_imp.m -- Local implementation of DBSCAN based on S. Mostapha Kalami Heris' code.
    
    zenodo_3983634/dbscan_postprocessing.m -- Postprocessing method
    
    zenodo_3983634/execDbscan.m -- All the execution methods DBSCAN (Plain DBSCAN and DBSCAN + Postprocessing method)
    
    zenodo_3983634/execDbscan.sh -- All the execution methods DBSCAN (Plain DBSCAN and DBSCAN + Postprocessing method) (run this file using the linux/macOS terminal)
    
    zenodo_3983634/execDbscanModPCA90.m -- DBSCAN + postprocessing method + PCA 90 (run this file using octave).
    
    zenodo_3983634/execDbscanModPCA90.sh -- DBSCAN + postprocessing method + PCA 90 (run this file using the linux/macOS terminal). 
    
    zenodo_3983634/execKNNBaseLine.m -- Plain KNN
    
    zenodo_3983634/execKNNBaseLine.sh -- Plain KNN (run this file using the linux/macOS terminal). 
    
    zenodo_3983634/knn_dbscan.m -- KNN + plain DBSCAN 
    
    zenodo_3983634/knn_dbscanmodpca.m -- KNN + DBSCAN + postprocessing method + PCA
    
    zenodo_3983634/knn_dbscanmod.m -- KNN + DBSCAN + postprocessing method 
    
    zenodo_3983634/cell2csv.m -- Write the cell content into a .csv file. Developed by Sylvain Fiedler, KA, 2004 (Online available: https://gist.github.com/jan-glx/5823346)
    
    zenodo_3983634/getCorrCoefMatrix.m -- Compute the coefficient correlation matrix
    
    zenodo_3983634/ResultsReport/generatePlots.m -- Plot comparison (three methods)
    
    zenodo_3983634/ResultsReport/resultsSummary.m -- Summary of the three implementation
    
    zenodo_3983634/ResultsReport/generateTable.m -- Generates the results table - csv output
    
    
     
### Running the project

If you want to run the project in linux/macOS terminal. 
* **Shell**
```bash
sh execKNNBaseLine.sh
sh execDbscan.sh
sh execDbscanModPCA90.sh
```
* **Octave**

Run the the following files.

```bash
execKNNBaseLine.m 
execDbscan.m
execDbscanModPCA90.m
```
