clear all; clc; close all;

% Generate summary results

warning('off', 'all');
addpath("../");
databases       = {'DSI1','DSI2','LIB1','LIB2','MAN1','MAN2','SIM001','TUT1','TUT2','TUT3','TUT4','TUT5'};
models          = {'knn_baseline','knn_dbscan','knn_dbscanmodpca', 'knn_dbscanmod'};
rep = 1;
sep = filesep();
results = "";
for db = 1:size(databases,2)
  for model = 1:size(models,2) 
    % for i = [3]
      [best_distance,best_rep,best_k,need_execution,Eps,MinPts,numberOfDimensions] = getOptimalParams(databases{db},3);
      
      if strcmp(models{model},'knn_baseline')
        [best_distance,best_rep,best_k,need_execution] = getOptimalParams(databases{db},2);
        results = ['Results' sep databases{db} sep models{model} sep  best_rep '_' strrep(best_distance,'distance_','') '_k' sprintf('%03d',best_k) sep 'results_rep' sprintf('%03d',rep) '.mat'] ;
      elseif strcmp(models{model},'knn_dbscan')
        results = ['Results' sep databases{db} sep models{model} '_eps_' sprintf('%.03f',Eps) '_minpts_'  sprintf('%03d',MinPts) sep best_rep '_' strrep(best_distance,'distance_','') '_k' sprintf('%03d',best_k) sep 'results_rep' sprintf('%03d',rep) '.mat'] ;
      elseif strcmp(models{model},'knn_dbscanmod')
        results = ['Results' sep databases{db} sep models{model} '_eps_' sprintf('%.03f',Eps) '_minpts_'  sprintf('%03d',MinPts) sep best_rep '_' strrep(best_distance,'distance_','') '_k' sprintf('%03d',best_k) sep 'results_rep' sprintf('%03d',rep) '.mat'] ;
      elseif strcmp(models{model},'knn_dbscanmodpca')
        [best_distance,best_rep,best_k,need_execution,Eps,MinPts,numberOfDimensions] = getOptimalParams(databases{db},4);
        results = ['Results' sep databases{db} sep models{model} '_eps_' sprintf('%.05f',Eps) '_minpts_'  sprintf('%03d',MinPts) '_dim_' sprintf('%03d',numberOfDimensions) sep best_rep '_' strrep(best_distance, 'distance_','') '_k' sprintf('%03d',best_k) sep 'results_rep' sprintf('%03d',rep) '.mat'] ;
      end
    
      if ~exist(results)
        fprintf('File not found : %s\n', results );
      else
        load(results);
        fprintf('---------------------------------------------------------------\n\n');
        fprintf('Database %s model %s\n', databases{db}, models{model} );
        fprintf('    Mean Positioning Error 2D*  : %3.3f\n',mean(results.error((results.error(:,4)==0),1)));
        fprintf('    Full time                   : %3.6f\n',results.timefull(3)); 
        fprintf('        Matching                : %3.3f%%\n',sum(results.timesample(:,3)-results.timesample(:,2))/results.timefull(3)*100); 
        fprintf('        Positioning             : %3.3f%%\n',sum(results.timesample(:,4)-results.timesample(:,3))/results.timefull(3)*100);
        fprintf('        Total online search time: %3.6f\n',sum(results.timesample(:,3)-results.timesample(:,2)) + sum(results.timesample(:,4)-results.timesample(:,3)));
      end
    %end      
  end
end
