function IDX = dbscan_postprocessing(IDX,D)
% Developed by: Darwin Quezada
% This function is devoted to join "noisy" samples into the clusters with a high 
% level of correlation.
% Parameters:
%   - IDX:        DBSCAN clustering indices
%   - D:          Distance matrix computed by DBSCAN

    
    fs = zeros(size(D,1),2);
    % Get the correlation coefficient matrix from the distance matrix
    Cs = getCorrCoefMatrix(D,D);
    fs(:,1) = sum(Cs,2);
    max_sim_level = max(fs(:,1));

    ord=(1:size(fs,1));
    comp_r = zeros(size(fs,1),2);
    
    for i = 1:size(fs,1)
        com_porc = (fs(i,1)*100)/max_sim_level;
        if com_porc > 10 && IDX(i) == 0
            comp_r = [ord' Cs(i,:)'];
            sort_r = sortrows(comp_r, -2);
            pos = 1;
            fnd = 0;
            while pos < size(fs,1) || fnd == 1
                if IDX(sort_r(pos,1)) ~= 0
                    IDX(i) = IDX(sort_r(pos,1));
                    pos = pos + 1;
                    fnd = 1;
                    break;
                else
                    pos = pos + 1;
                end
             
                if pos == size(fs,1)
                    break;
                end
            end
        end
    end
end
