clear all; clc; close all;

% Generate summery results
% Table
warning('off', 'all');
addpath("../");
databases       = {'DSI1','DSI2','LIB1','LIB2','MAN1','MAN2','SIM001','TUT1','TUT2','TUT3','TUT4','TUT5'};
models          = {'knn_dbscan', 'knn_dbscanmod', 'knn_dbscanmodpca'};
rep = 1;
sep = filesep();
results = "";
num_subplot = 1;
for db = 1:1%size(databases,2)
  for model = 1:2%size(models,2) 
    folderClusters = ['Clusters' sep databases{db} sep 'knn_dbscan' sep] ;
    mdl = strrep(models{model}, "knn", "clusters");
    if strcmp(models{model},'knn_dbscanmodpca')
      [best_distance,best_rep,best_k,need_execution,Eps,MinPts,numberOfDimensions] = getOptimalParams(databases{db},4);
      cluster = [folderClusters, mdl,'_',best_rep,'_eps_', sprintf('%.05f',Eps), '_minpts_', sprintf('%03d',MinPts),'_dim_',sprintf('%03d',numberOfDimensions),'.mat'];
    else
      [best_distance,best_rep,best_k,need_execution,Eps,MinPts,numberOfDimensions] = getOptimalParams(databases{db},3);
      cluster = [folderClusters, mdl,'_',best_rep,'_eps_', sprintf('%.03f',Eps), '_minpts_', sprintf('%03d',MinPts),'.mat'];
    end
    
    if ~exist(cluster)
      fprintf('File not found : %s\n', cluster );
    else
      load(cluster);
      srt = sort(clusters.idx);
      SC = zeros(max(srt)+1,1);
      C = zeros(max(srt)+1,1);
      b=1;
      for i = 0:max(srt)
        C(b) = i;
          for x = 1:size(srt,1)
              if C(b) == srt(x)
                  SC(b) = SC(b) + 1;
              end
          end
          b=b+1;
      end
      
      subplot(2,1,num_subplot);
      bar(C,SC)
      title(['Distribution of clusters ' databases{db} ' dataset - ' toupper(strrep(models{model}, "knn_", "")) ])
      hold on;
      num_subplot = num_subplot + 1;
    end
  end
  hold off;
end
