clear;clc;pack; more off;

close all;
fclose all;

databases       = {'DSI1','DSI2','LIB1','LIB2','MAN1','MAN2','SIM','TUT1','TUT2','TUT3','TUT4','TUT5'};
models          = {'knn_baseline','knn_dbscan','knn_dbscanmod','knn_dbscanmodpca'};


fid_script_sh = fopen('execKNNBaseLine.sh','w');
fid_script_mo = fopen('execKNNBaseLine.m','w');

file_id  = 1;

for repetition = 1:1
  
  repetition 
  
  for db = 1:size(databases,2)
    
    currentDatabase   = databases{db};
    currentRepetition = repetition;
    if strfind(currentDatabase,'SIM')
      currentDatabase   = [currentDatabase sprintf('%03d',repetition) ];
      currentRepetition = 1;
    end      
    
    for i=[3]
      
      features = getFeaturesDB(databases{db});  
      [best_distance,best_rep,best_k,need_execution,eps,minPts,numberOfDimensions] = getOptimalParams(databases{db},i);
      
      % clustering = 'knn_baseline';
      % fprintf(fid_script_sh,'echo "file%06d.txt";\n',file_id); 
      % fprintf(fid_script_sh,"octave --eval \"runMethod('%s','%s','%s','%s',%d,%d);\" > file%06d.txt\n",currentDatabase,best_rep,clustering,best_distance,best_k,currentRepetition,file_id); file_id = file_id + 1; 
      % fprintf(fid_script_mo,"runMethod('%s','%s','%s','%s',%d,%d);\n",currentDatabase,best_rep,clustering,best_distance,best_k,currentRepetition); 
      
      
      clustering = 'knn_dbscan';
      
      fprintf(fid_script_sh,'echo "file%06d.txt";\n',file_id); 			                                                 
      fprintf(fid_script_sh,"octave --eval \"runDbscan('%s','%s','%s','%s',%d,%d,%d,%d,%d,'%s');\" > file%06d.txt\n",currentDatabase,best_rep,clustering,best_distance,best_k,currentRepetition,eps,minPts,sprintf('%04d',00),file_id); file_id = file_id + 1; 
      fprintf(fid_script_mo,"runDbscan('%s','%s','%s','%s',%d,%d,%d,%d);\n",currentDatabase,best_rep,[clustering,],best_distance,best_k,currentRepetition,eps,minPts);
      
      
      % clustering = 'knn_dbscanmodpca';
      
      % fprintf(fid_script_sh,'echo " file%06d.txt";\n',file_id); 			                                                 
      % fprintf(fid_script_sh,"octave --eval \"runDbscanmodpca('%s','%s','%s','%s',%d,%d,%d,%d,%d);\" > file%06d.txt\n",currentDatabase,best_rep,clustering,best_distance,best_k,currentRepetition,eps,minPts,numberOfDimensions,file_id); file_id = file_id + 1; 
      % fprintf(fid_script_mo,"runDbscanmodpca('%s','%s','%s','%s',%d,%d,%d,%d,%d);\n",currentDatabase,best_rep,[clustering,],best_distance,best_k,currentRepetition,eps,minPts,numberOfDimensions);
      
      
      clustering = 'knn_dbscanmod';
      
      fprintf(fid_script_sh,'echo "file%06d.txt";\n',file_id); 			                                                 
      fprintf(fid_script_sh,"octave --eval \"runDbscan('%s','%s','%s','%s', %d, %d, %d, %d, %d,'%s');\" > file%06d.txt\n",currentDatabase,best_rep,clustering,best_distance,best_k,currentRepetition,eps,minPts,sprintf('%04d',00),file_id); file_id = file_id + 1; 
      fprintf(fid_script_mo,"runDbscan('%s','%s','%s','%s',%d,%d,%d,%d);\n",currentDatabase,best_rep,[clustering,],best_distance,best_k,currentRepetition,eps,minPts);
      
      
    end
    
  end
  
end



fclose all;
