function Cs = getCorrCoefMatrix(x,y)
 % Compute the correlation coefficient
    if isvector(x) || isvector(y)
        if length(x)~=length(y)
            error('x and y have to be same length!')
        end
        Cs = computeCorrCoefVal(x,y);
    else
        if size(x,2)~=size(y,2)
            error('x and y have to be same length!')
        end

        rowx = size(x,1);
        rowy = size(y,1);
        Cs = zeros(rowx,rowy);

        for i = 1:rowx
            for j = 1:rowy
                Cs(i,j)= computeCorrCoefVal(x(i,:),y(j,:));
            end
        end
    end
end


function Cs = computeCorrCoefVal(x,y)
    Cs = corrcoef(x,y);
    Cs = Cs(1,2);
end
