function [best_distance,best_rep,best_k,need_execution, eps, minPts, numberOfDimensions] = getOptimalParams (database,optionExec)

need_execution=1;

if optionExec == 1

best_distance = 'distance_euclidean'; best_rep='positive'; best_k=1;

elseif optionExec == 2

if strcmp(database,'DSI1'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=60; minPts=3; end
if strcmp(database,'DSI2'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=150; minPts=2; end
if strcmp(database,'LIB1'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=160; minPts=4; end
if strcmp(database,'LIB2'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=66; minPts=2; end
if strcmp(database,'MAN1'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=20; minPts=3; end
if strcmp(database,'MAN2'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=19; minPts=3; end
if strcmp(database,'TUT1'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=290; minPts=2; end
if strcmp(database,'TUT2'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=290; minPts=2; end
if strcmp(database,'TUT3'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=290; minPts=2; end
if strcmp(database,'TUT4'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=135; minPts=2; end
if strcmp(database,'TUT5'); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=180; minPts=2; end
if size(strfind(database,'SIM'),1); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=1; eps=3; minPts=2; end

elseif optionExec == 3

% Optimal parameter Plain DBSCAN and DBSCAN + post-processing method
if strcmp(database,'DSI1'); best_distance = 'distance_sorensen'; best_rep='powed'; best_k=11; eps=0.17; minPts=2; numberOfDimensions = 64; end
if strcmp(database,'DSI2'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=9; eps=150; minPts=2; numberOfDimensions = 61; end
if strcmp(database,'LIB1'); best_distance = 'distance_squaredeuclidean'; best_rep='positive'; best_k=11; eps=160; minPts=2; numberOfDimensions = 31; end
if strcmp(database,'LIB2'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=9; eps=66; minPts=2; numberOfDimensions = 55; end
if strcmp(database,'MAN1'); best_distance = 'distance_cityblock'; best_rep='exponential'; best_k=11; eps=0.031; minPts=3; numberOfDimensions = 16; end
if strcmp(database,'MAN2'); best_distance = 'distance_neyman'; best_rep='exponential'; best_k=11; eps=0.033; minPts=3; numberOfDimensions = 8; end
if strcmp(database,'TUT1'); best_distance = 'distance_PLGD40'; best_rep='positive'; best_k=3; eps=290; minPts=2; numberOfDimensions = 51; end
if strcmp(database,'TUT2'); best_distance = 'distance_sorensen'; best_rep='powed'; best_k=1; eps=0.033; minPts=2; numberOfDimensions = 56; end
if strcmp(database,'TUT3'); best_distance = 'distance_sorensen'; best_rep='positive'; best_k=3; eps=290; minPts=2; numberOfDimensions = 108; end
if strcmp(database,'TUT4'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=3; eps=135; minPts=2; numberOfDimensions = 188; end
if strcmp(database,'TUT5'); best_distance = 'distance_PLGD40'; best_rep='positive'; best_k=3; eps=180; minPts=2; numberOfDimensions = 49; end
if size(strfind(database,'SIM'),1); best_distance = 'distance_squaredeuclidean'; best_rep='exponential'; best_k=11; eps=0.012; minPts=2; numberOfDimensions = 5; end

elseif optionExec == 4

% Optimal parameter DBSCAN + PCA
if strcmp(database,'DSI1'); best_distance = 'distance_sorensen'; best_rep='powed'; best_k=11; eps=0.005; minPts=2; numberOfDimensions = 64; end
if strcmp(database,'DSI2'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=9; eps=0.015; minPts=2; numberOfDimensions = 61; end
if strcmp(database,'LIB1'); best_distance = 'distance_squaredeuclidean'; best_rep='positive'; best_k=11; eps=0.01; minPts=2; numberOfDimensions = 31; end
if strcmp(database,'LIB2'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=9; eps=0.01; minPts=2; numberOfDimensions = 55; end
if strcmp(database,'MAN1'); best_distance = 'distance_cityblock'; best_rep='exponential'; best_k=11; eps=0.006; minPts=3; numberOfDimensions = 16; end
if strcmp(database,'MAN2'); best_distance = 'distance_neyman'; best_rep='exponential'; best_k=11; eps=0.00111; minPts=3; numberOfDimensions = 8; end
if strcmp(database,'TUT1'); best_distance = 'distance_PLGD40'; best_rep='positive'; best_k=3; eps=0.00921; minPts=2; numberOfDimensions = 51; end
if strcmp(database,'TUT2'); best_distance = 'distance_sorensen'; best_rep='powed'; best_k=1; eps=0.0051; minPts=2; numberOfDimensions = 56; end
if strcmp(database,'TUT3'); best_distance = 'distance_sorensen'; best_rep='positive'; best_k=3; eps=0.021; minPts=2; numberOfDimensions = 108; end
if strcmp(database,'TUT4'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=3; eps=0.009; minPts=2; numberOfDimensions = 188; end
if strcmp(database,'TUT5'); best_distance = 'distance_PLGD40'; best_rep='positive'; best_k=3; eps=0.0041; minPts=2; numberOfDimensions = 49; end
if size(strfind(database,'SIM'),1); best_distance = 'distance_squaredeuclidean'; best_rep='exponential'; best_k=11; eps=0.0006; minPts=2; numberOfDimensions = 5; end

elseif optionExec == 5


best_distance = 'distance_squaredeuclidean';
best_rep      = 'positive';
if strcmp(database,'DSI1'); best_k=11; end
if strcmp(database,'DSI2'); best_k=11; end
if strcmp(database,'LIB1'); best_k=11; end
if strcmp(database,'LIB2'); best_k=11; end
if strcmp(database,'MAN1'); best_k=11; end
if strcmp(database,'MAN2'); best_k=11;end
if strcmp(database,'TUT1'); best_k=5;  end
if strcmp(database,'TUT2'); best_k=3; end
if strcmp(database,'TUT3'); best_k=3;  end
if strcmp(database,'TUT4'); best_k=3; end
if strcmp(database,'TUT5'); best_k=3; end

if size(strfind(database,'SIM'),1); best_k=11;end

elseif optionExec == 6

if strcmp(database,'DSI1'); best_distance = 'distance_sorensen'; best_rep='positive'; best_k=9; end
if strcmp(database,'DSI2'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=9; need_execution=0; end
if strcmp(database,'LIB1'); best_distance = 'distance_squaredeuclidean'; best_rep='positive'; best_k=11; need_execution=0; end
if strcmp(database,'LIB2'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=9;need_execution=0; end
if strcmp(database,'MAN1'); best_distance = 'distance_sorensen'; best_rep='positive'; best_k=11; end
if strcmp(database,'MAN2'); best_distance = 'distance_squaredeuclidean'; best_rep='positive'; best_k=11; end
if strcmp(database,'TUT1'); best_distance = 'distance_PLGD40'; best_rep='positive'; best_k=3; need_execution=0; end
if strcmp(database,'TUT2'); best_distance = 'distance_PLGD40'; best_rep='positive'; best_k=7; end
if strcmp(database,'TUT3'); best_distance = 'distance_sorensen'; best_rep='positive'; best_k=3; need_execution=0; end
if strcmp(database,'TUT4'); best_distance = 'distance_PLGD10'; best_rep='positive'; best_k=3; need_execution=0;end
if strcmp(database,'TUT5'); best_distance = 'distance_PLGD40'; best_rep='positive'; best_k=3; need_execution=0;end
if size(strfind(database,'SIM'),1); best_distance = 'distance_cityblock'; best_rep='positive'; best_k=11;end


end
