function  runDbscan(databaseName,datarep,clustering,distanceMetric,k,repetitions,Eps,MinPts)
  
  if exist('OCTAVE_VERSION', 'builtin') ~= 0
    saveOption = '-mat7-binary';
  else
    saveOption = '-mat';
  end
  
  sep = filesep();
  
  database = loadDatabase('databases', databaseName);
  defaultNonDetectedValue = 100; 
  newNonDetectedValue     = min([database.trainingMacs(:);database.testMacs(:)]) - 1;
  
  for i = repetitions
    
    fprintf('%s -- %s repetition %d of %d',clustering,databaseName,i,repetitions(end));
    
    if   size(strfind(clustering,'knn_dbscan'),1)
      
      folderClusters = ['Clusters' sep databaseName sep 'knn_dbscan' sep] ;
      
      [results,clusters]  = feval(clustering, database , k, datarep, ...
      defaultNonDetectedValue, newNonDetectedValue , ...
      distanceMetric, Eps, MinPts, folderClusters);  
      folderResults = ['Results' sep databaseName sep clustering '_eps_' sprintf('%.03f',Eps) '_minpts_'  sprintf('%03d',MinPts) sep datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k)] ;
      
    elseif   size(strfind(clustering,'knn_dbscanmod'),1)
      
      folderClusters = ['Clusters' sep databaseName sep 'knn_dbscanmod' sep] ;
      
      [results,clusters]  = feval(clustering, database , k, datarep, ...
      defaultNonDetectedValue, newNonDetectedValue , ...
      distanceMetric, Eps, MinPts, folderClusters);  
      folderResults = ['Results' sep databaseName sep clustering '_eps_' sprintf('%.03f',Eps) '_minpts_'  sprintf('%03d',MinPts) sep datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k)] ;
      
    end
    
    if ~exist(folderResults)
      mkSubdirs(folderResults);
    end
    save([folderResults sep 'results_rep' sprintf('%03d',i) '.mat' ],'results',saveOption)

  end