function  runDbscanmodpca (databaseName,datarep,clustering,distanceMetric,k,repetitions,Eps,MinPts,numberOfDimensions)
  
  if exist('OCTAVE_VERSION', 'builtin') ~= 0
    saveOption = '-mat7-binary';
  else
    saveOption = '-mat';
  end

  
  sep = filesep();
  
  database = loadDatabase('databases',databaseName);
  defaultNonDetectedValue = 100; 
  newNonDetectedValue     = min([database.trainingMacs(:);database.testMacs(:)]) - 1;
  
  for i = repetitions
    
    fprintf('%s -- %s repetition %d of %d',clustering,databaseName,i,repetitions(end));
    
    if   size(strfind(clustering,'knn_dbscanmodpca'),1)
      folderClusters = ['Clusters' sep databaseName sep 'knn_dbscanmodpca' sep] ;
     
      [results,clusters]  = feval(clustering, database , k, datarep, ...
      defaultNonDetectedValue, newNonDetectedValue , ...
      distanceMetric, Eps, MinPts, folderClusters, numberOfDimensions);  
      folderResults = ['Results' sep databaseName sep clustering '_eps_' sprintf('%.05f',Eps) '_minpts_'  sprintf('%03d',MinPts) '_dim_' sprintf('%03d',numberOfDimensions) sep datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k)] ;
      
    end
    
    if ~exist(folderResults)
      mkSubdirs(folderResults);
    end
    save([folderResults sep 'results_rep' sprintf('%03d',i) '.mat' ],'results',saveOption)
    
  end