function  runMethod (databaseName,datarep,clustering,distanceMetric,k,repetitions)
  
  if exist('OCTAVE_VERSION', 'builtin') ~= 0
    saveOption = '-mat7-binary';
  else
    saveOption = '-mat';
  end
  
  sep = filesep();
  
  database = loadDatabase('databases',databaseName);
  defaultNonDetectedValue = 100; 
  newNonDetectedValue     = min([database.trainingMacs(:);database.testMacs(:)]) - 1;
  
  saveClusters = 1; 
  
  for i = repetitions
    
    fprintf('%s -- %s repetition %d of %d',clustering,databaseName,i,repetitions(end));
    
    if strcmp(clustering,'knn_baseline')            

      results  = feval(clustering, database , k, datarep, ...
      defaultNonDetectedValue, newNonDetectedValue , ...
      distanceMetric );  
      
      folderResults = ['Results' sep databaseName sep clustering sep  datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k) sep] ;
      
    end
    
    
    if ~exist(folderResults)
      mkSubdirs(folderResults);
    end
    save([folderResults sep 'results_rep' sprintf('%03d',i) '.mat' ],'results',saveOption)
    
  end
  
